apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: ssh
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: backups-{{ medusa_name }}
    backups.opsperator.io/service: backups-{{ medusa_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ medusa_name }}
  name: {{ medusa_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ medusa_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ medusa_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ medusa_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ medusa_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ medusa_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ medusa_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: ADMIN_PASS
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ medusa_name }}
        - name: ADMIN_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ medusa_name }}
        - name: API_KEY
          valueFrom:
            secretKeyRef:
              key: api-key
              name: {{ medusa_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DISABLE_AUTH
          value: "{% if do_lemon or do_ldap %}yay{% endif %}"
{% if do_sab %}
        - name: DOWNLOAD_URL
          value: {{ sabnzbd_downloads_public }}
{% endif %}
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
{% if do_newznab %}
        - name: NEWZNAB_API_KEY
          valueFrom:
            secretKeyRef:
              key: api-key
              name: {{ newznab_name }}
        - name: NEWZNAB_HOST
          value: {{ newznab_api_address | urlsplit('hostname') }}
        - name: NEWZNAB_PORT
          value: "{{ newznab_api_address | urlsplit('port') }}"
        - name: NEWZNAB_PROTO
          value: {{ newznab_api_address | urlsplit('scheme') }}
{% endif %}
{% if do_sab %}
        - name: SABNZB_API_KEY
          valueFrom:
            secretKeyRef:
              key: api-key
              name: {{ sabnzbd_name }}
        - name: SABNZB_HOST
          value: {{ sabnzbd_api_address | urlsplit('hostname') }}
        - name: SABNZB_PORT
          value: "{{ sabnzbd_api_address | urlsplit('port') }}"
        - name: SABNZB_PROTO
          value: {{ sabnzbd_api_address | urlsplit('scheme') }}
{% endif %}
        - name: SMTP_FROM
          value: {{ medusa_smtp_mailfrom if (medusa_smtp_mailfrom | default(False)) else ('medusa@' ~ root_domain) }}
        - name: SMTP_PORT
{% if smtp_relay | default(False) %}
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_RELAY
          value: {{ smtp_relay }}
{% elif smtps_address | default(False) %}
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_RELAY
          value: {{ smtps_address | urlsplit('hostname') }}
{% elif smtp_address | default(False) %}
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_RELAY
          value: {{ smtp_address | urlsplit('hostname') }}
{% else %}
          value: ""
        - name: SMTP_RELAY
          value: ""
{% endif %}
        - name: SMTP_TO
          value: {{ medusa_smtp_mailto if (medusa_smtp_mailto | default(False)) else ('admin0@' ~ root_domain) }}
{% if do_transmission %}
        - name: TRANSMISSION_HOST
          value: {{ transmission_api_address | urlsplit('hostname') }}
        - name: TRANSMISSION_PASS
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ transmission_name }}
        - name: TRANSMISSION_PORT
          value: "{{ transmission_api_address | urlsplit('port') }}"
        - name: TRANSMISSION_PROTO
          value: {{ transmission_api_address | urlsplit('scheme') }}
        - name: TRANSMISSION_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ transmission_name }}
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='medusa'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='medusa'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 30
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 8
        name: medusa
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            path: /
            port: 8080
          initialDelaySeconds: 5
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ medusa_cpu_limit }}"
            memory: "{{ medusa_memory_limit }}"
          requests:
            cpu: "{{ medusa_cpu_request }}"
            memory: "{{ medusa_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 30
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
{% if (smtps_address | default(False) or do_transmission or do_newznab or do_sab) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /config
          name: data
          subPath: config
        - mountPath: /download
          name: data
          subPath: download
        - mountPath: /tv
          name: data
          subPath: tv
        - mountPath: /anime
          name: data
          subPath: anime
{% if do_lemon or do_ldap %}
      - env:
        - name: AUTH_METHOD
{% if do_lemon %}
          value: oidc
{% else %}
          value: ldap
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DO_WEBSOCKETS
          value: yay
        - name: OIDC_CALLBACK_URL
{% if do_lemon %}
          value: /oauth2/callback
        - name: OIDC_CLIENT_ID
          value: medusa
        - name: OIDC_CLIENT_SECRET
          valueFrom:
            secretKeyRef:
              key: medusa-oauth2-secret
              name: {{ ldap_secret_name }}
        - name: OIDC_CRYPTO_SECRET
          valueFrom:
            secretKeyRef:
              key: oidc-crypto-secret
              name: {{ medusa_name }}
        - name: OIDC_META_URL
          value: /.well-known/openid-configuration
        - name: OIDC_PORTAL
          value: {{ lemon_portal }}
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: client_secret_basic
{% else %}
          value: ""
        - name: OIDC_CLIENT_ID
          value: ""
        - name: OIDC_CLIENT_SECRET
          value: ""
        - name: OIDC_CRYPTO_SECRET
          value: ""
        - name: OIDC_META_URL
          value: ""
        - name: OIDC_PORTAL
          value: ""
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: ""
{% endif %}
        - name: OPENLDAP_BASE
{% if do_lemon %}
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
        - name: OPENLDAP_USERS_OBJECTCLASS
          value: ""
        - name: PING_PATH
          value: /ping
{% else %}
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=authproxy,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: authproxy-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ medusa_ldap_user_objectclass }}
{% endif %}
        - name: PING_PATH
          value: ""
{% endif %}
        - name: PROXY_BACKEND_HOST
          value: 127.0.0.1
        - name: PROXY_BACKEND_PORT
          value: "8080"
        - name: PROXY_BACKEND_PROTO
          value: http
        - name: PROXY_HTTP_PORT
          value: "8081"
        - name: PROXY_PROTO
          value: http
        - name: PROXY_SERVER_NAME
          value: {{ medusa_fqdn }}
        - name: PUBLIC_PROTO
          value: https
        - name: TZ
          value: {{ timezone }}
        - name: WS_PATH
          value: ws
{% if do_triggers == False or (opsimages | json_query("[?name=='authproxy'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='authproxy'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 30
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            httpHeaders:
            - name: Host
{% if do_lemon %}
              value: {{ medusa_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8081
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 8
        name: authproxy
        ports:
        - containerPort: 8081
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
{% if do_lemon %}
              value: {{ medusa_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8081
          initialDelaySeconds: 5
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ authproxy_cpu_limit }}"
            memory: "{{ authproxy_memory_limit }}"
          requests:
            cpu: "{{ authproxy_cpu_request }}"
            memory: "{{ authproxy_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 92
          initialDelaySeconds: 10
          periodSeconds: 10
          tcpSocket:
            port: 8081
{% endif %}
        volumeMounts:
{% if k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: temp
          subPath: apache
{% if do_ldap and not do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /etc/ssl/certs
          name: temp
          subPath: certs
        - mountPath: /usr/local/share/ca-certificates
          name: temp
          subPath: ca-certificates
        - mountPath: /usr/share/ca-certificates
          name: temp
          subPath: empty
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8081/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% endif %}
{% endif %}
{% if do_backups %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /home/backup
          name: temp
          subPath: bkphome
        - mountPath: /var/backup
          name: temp
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
{% if do_exporters and (do_lemon or do_ldap) %}
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ medusa_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: data
        persistentVolumeClaim:
          claimName: {{ medusa_name }}
{% if do_ldap and not do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False) or do_transmission or do_newznab or do_sab) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap or do_lemon %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if do_newznab | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: newznab-ca.crt
{% if newznab_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if do_transmission | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: transmission-ca.crt
{% if transmission_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if do_sab %}
          - secret:
              items:
              - key: ca.crt
                path: sabnzbd-ca.crt
{% if sabnzbd_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if do_backups %}
      - name: ssh
        secret:
          secretName: backups-{{ medusa_name }}
{% endif %}
      - emptyDir: {}
        name: temp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='medusa'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - medusa
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='medusa'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if (do_lemon or do_ldap) and (opsimages | json_query("[?name=='authproxy'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - authproxy
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='authproxy'].short"))[0] }}
        namespace: {{ buildns }}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% endif %}
{% if do_backups and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
